SoShaderObject(3)

NAME
SoShaderObject - The SoShaderObject class is the superclass for all shader classes in Coin.

SYNOPSIS

#include <Inventor/nodes/SoShaderObject.h>

Inherits SoNode.

Inherited by SoFragmentShader, SoGeometryShader, and SoVertexShader.

  Public Types
enum SourceType { ARB_PROGRAM, CG_PROGRAM, GLSL_PROGRAM, FILENAME }

  Public Member Functions
virtual SoType getTypeId (void) const
virtual void GLRender (SoGLRenderAction *action)
virtual void search (SoSearchAction *action)
void updateParameters (SoState *state)
SourceType getSourceType (void) const
SbString getSourceProgram (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFBool isActive
SoSFEnum sourceType
SoSFString sourceProgram
SoMFNode parameter

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
SoShaderObject (void)
virtual ~SoShaderObject ()
virtual SbBool readInstance (SoInput *in, unsigned short flags)

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoShaderObject class is the superclass for all shader classes in Coin. See Shaders in Coin for more information on how to set up a scene graph with shaders.

See also
    SoShaderProgram

Member Enumeration Documentation

  enum SoShaderObject::SourceType
Used for enumerating the shader types in sourceProgram.

Enumerator

ARB_PROGRAM
    Specifies an ARB shader.

CG_PROGRAM
    Specifies a Cg shader program.

GLSL_PROGRAM
    Specifies a GLSL program.

FILENAME
    Shader should be loaded from the file in sourceProgram.

Constructor & Destructor Documentation

  SoShaderObject::SoShaderObject (void) [protected]
Constructor.

  SoShaderObject::~SoShaderObject () [protected], [virtual]
Destructor

Member Function Documentation

  SoType SoShaderObject::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoShaderObject::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

Reimplemented in SoFragmentShader, SoGeometryShader, and SoVertexShader.

  const SoFieldData ** SoShaderObject::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoShaderObject::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

Reimplemented in SoFragmentShader, SoGeometryShader, and SoVertexShader.

  void SoShaderObject::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

Reimplemented in SoGeometryShader.

  void SoShaderObject::search (SoSearchAction * action) [virtual]
Action method for SoSearchAction.

Compares the search criteria from the action to see if this node is a match. Searching is done by matching up all criteria set up in the SoSearchAction -- if any of the requested criteria is a miss, the search is not deemed successful for the node.

See also
    SoSearchAction

Reimplemented from SoNode.

  void SoShaderObject::updateParameters (SoState * state)
Used internally to update shader parameters.

  SoShaderObject::SourceType SoShaderObject::getSourceType (void) const
Returns the shader type detected in source program.

  SbString SoShaderObject::getSourceProgram (void) const
Returns the actual shader program.

  SbBool SoShaderObject::readInstance (SoInput * in, unsigned short flags) [protected], [virtual]
This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

TRUE or FALSE is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning FALSE.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoNode.

Member Data Documentation

  SoSFBool SoShaderObject::isActive
Enabled/disables the shader. Default value is TRUE.

  SoSFEnum SoShaderObject::sourceType
The type of shader.

  SoSFString SoShaderObject::sourceProgram
The shader program, or a file name if the shader should be loaded from a file. If the shader is loaded from a file, the shader type is identified by the file extension. .glsl for GLSL shaders, .cg for Cg shaders, and .vp and .fp for ARB shaders.

  SoMFNode SoShaderObject::parameter
The shader program parameters.

Author

Generated automatically by Doxygen for Coin from the source code.